/* KI Maximums */

#define STSIZE 		80
#define MAXLINE 	255
#define PVSIZE 		50
#define MAXTOKEN 	100
#define NBUFSIZE 	200		/* Name buffer size */
#define PATHSIZE	100		/* Full pathname size */
#define CMDLNSIZE	100		/* Command line size. */

/* get_token codes. */

#define ALPHA 			101
#define NUMERIC 		102
#define LITERAL 		103
#define DECIMAL 		104
#define OCTAL 			105
#define UNDEF 			106
#define LPROC 			107
#define VARIABLE 		108
#define CONST 			109
#define UPROC 			110
#define NAME 			111
#define ENDST 			112

#define NOT_NUMERIC_ERROR 	120
#define NOT_HEX_ERROR 		121
#define NOT_TERMINATED_ERROR 	122
#define TOKEN_LEN_ERROR 	123

/* Misc defines. */

#define NORMAL 		0
#define IABORT 		1
#define OSABORT 	2

#define NOTFOUND 	0
#define FOUND 		1

#define TRUE		1
#define FALSE		0

#define OFF 		0
#define ON 		1

#define STOP 		0
#define RUN 		1

#define LOW 		0
#define HIGH 		1

#define CLSE 		0
#define OPN 		1

#define	CMD_FILE	0
#define	CMD_LINE	1

#define _COM1 	0
#define _COM2 	1
#define _COM3 	2
#define _COM4 	3

/* Line Status byte drom _bios_serialcom */

#define DATA_READY		0x100     /* bit 8  = data ready */
#define DATA_OVERRUN		0x200     /* bit 9  = data overrun */
#define DATA_PARITY_ERROR	0x400     /* bit 10 = parity error */
#define DATA_FRAMING_ERROR	0x800     /* bit 11 = framing error */
#define DATA_TIMEOUT		0x8000    /* bit 15 = timeout */

/* KI Data structures. */

typedef struct table_entry *entry_ptr;
extern struct table_entry symtab[];

typedef entry_ptr *pv_ptr;
extern entry_ptr pv[];

struct table_entry {
	char *name ;
	int type;
	union {
		int value ;
		pv_ptr (*lproc)();
		pv_ptr uproc ;
		} uval;
	};


