/* Interpreter symbol table and language procedure definitions. */

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <errno.h>
#include <conio.h>
#include <string.h>

#include <at200.h>
#include <camera.h>

#include "idecls.h"
#include "camsys.h"
#include "proto.h"

struct table_entry symtab[STSIZE] ;

extern pv_ptr clause();

/* Language procedure definitions. */

/* do loop. Supports both forms (do n and do i=n,m ) */

pv_ptr doproc( register pv_ptr p )
{
	pv_ptr 		localp, newp;
	entry_ptr 	cvar;
	int 		typ, val, max, i;

	newp = clause (p, &typ, &val);	/* Get arg 1 */
	switch ( typ )
	{
	case CONST:
		max = val ;
		localp = newp ;
		for (i=0; i<max && abrt == NORMAL; i++)
		{
			p = localp ;
			newp = clause(p, &typ, &val) ;
		}
		break ;
	case VARIABLE:
		cvar = *p ;
		newp = clause(newp, &typ, &val) ;
		localp = clause(newp, &typ, &max) ;
		for ((*cvar).uval.value=val; (*cvar).uval.value <= max
			&& abrt == NORMAL; ++(*cvar).uval.value)
		{
			p = localp ;
			newp = clause( p, &typ, &val) ;
		}
		break;
	}
	return( newp );
}

/* 'begin' / 'end' capability */

pv_ptr begin ( register pv_ptr p )
{
	int typ, val ;
	while(*p != NULL && abrt == NORMAL && (**p).type != ENDST)
		p = clause (p, &typ, &val) ;
	return (p) ;
}

/* execute interpreter, taking input from file "fname" */

pv_ptr ixeq ( register pv_ptr p )  
{
	register pv_ptr newp;
	register char *ep;
	entry_ptr localpv[50];
	int t,v,len,next;
	FILE *fp;
	char line[ MAXLINE+1 ];
	char xeqfilename[100];
	
	newp = clause (p, &t, &v);
	strcpy( xeqfilename, scriptpath );    /* XEQ file from KI_SCRIPT path */
	strcat( xeqfilename, (**p).name );
	if ((fp=fopen( xeqfilename,"r"))==NULL)
	{
		fprintf(stderr,"Can't open %s.\n", xeqfilename );
		abrt = IABORT ;
		return(newp);
	}
	while (abrt == NORMAL)
	{
		if ((len=getline(fp,line,MAXLINE))==EOF) break ;
		if (len==MAXLINE)
		{
			fprintf(stderr,"Line in file %s too long.\n",
				xeqfilename );
			abrt == IABORT ;
			break ;
		}
		if ( ( ep = iparse( line, &localpv[0], &next ) ) != NULL )
		{
			fprintf (stderr,"%s",ep) ;
			abrt = IABORT ;
			break ;
		}
		localpv[next] = NULL ;
		iexec(localpv) ;
		if ( kbhit() ){
                  if ((len=getline( stdin, line, MAXLINE ))==EOF) break ;
                  fflush( stdin );
                }
		else
		  chron_func();		/* Give background some time. */
	}
	fclose(fp) ;
	return (newp) ;
}

/* execute system call for "command" */

pv_ptr isys ( register pv_ptr p )
{
	register pv_ptr newp ;
	int t, v ;
	newp = clause (p, &t, & v) ;
	system ((**p).name) ;
	return (newp) ;
}

/* Sleep interpreter for n sec.
 * Check to see if chron_func needs to do any work during this interval.
 */

pv_ptr isleep ( register pv_ptr p ) 
{
	unsigned int t, n;
	unsigned long	tick1, tick2, tick3;	/* 1 tick = 1 second */

	p = clause (p, &t, &n) ;	/* Get sleep interval */

	_dos_gettime( &tm );

	tick1 = ((long) tm.hour * 3600L) + ((long) tm.minute * 60L) 
			+ (long) tm.second;

	tick2 = tick1 + (long) n;		/* Bailout time. */

	do 
	{
		chron_func();
		tick3 = ((long) tm.hour * 3600L) 
			+ ((long) tm.minute * 60L) 
			+ (long) tm.second;
		if ( tick3 < tick1 )	
			return (p) ;	/* Exit if clock wraparound, */
#ifdef SKIP		
		if ( kbhit() )
			return (p) ;	/* or if any key is hit,  */
#endif		
		/* or if sleep interval expired. */
		
	} while ( tick3 < tick2 ); 

	return (p) ;
}

/* wait until a character is typed. Ctrl-d terminates current  line */

pv_ptr ipause ( register pv_ptr p ) 
{
	int c ;
	while ( !kbhit() )		/* Wait until some key is hit. */
	{
		chron_func();
	}
	if ((c = getchar()) == EOF) abrt = IABORT ;	/* swallow input */
	return (p) ;
}
 
pv_ptr ibeep ( register pv_ptr p ) 
{
	printf( "%c", 7 );
	return (p) ;
}
 

pv_ptr date ( register pv_ptr p )
{
	system("date") ;
	return (p) ;
}

pv_ptr prt ( register pv_ptr p )
{
	int typ, val ;
	register pv_ptr newp ;
	newp = clause(p, &typ, &val);
	printf ("%d\n",val) ;
	return (newp) ;
}

pv_ptr stop_ki ( register pv_ptr p )	/* Shutdown interpreter. */
{
	abrt = OSABORT;
	return ( p );
}

/* Return the BIOS clock tick counter value */

long dos_ticks( void )
{ 
  return( *((long far *) 0x46CL) );
}


