#include <stdio.h>
#include <dos.h>
#include <at200.h>

#include "idecls.h"
#include "camsys.h"
#include "proto.h"

/* Symbol table initialization. */

void st_init( void )
{
	register int i ;

	symtab[0].name = "date" ;
	symtab[0].type = LPROC ;
	symtab[0].uval.lproc = date ;

	symtab[1].name = "print" ;
	symtab[1].uval.lproc = prt ;
	symtab[1].type = LPROC ;

	symtab[2].name = "do" ;
	symtab[2].type = LPROC ;
	symtab[2].uval.lproc = doproc ;

	symtab[3].name = "begin" ;
	symtab[3].type = LPROC ;
	symtab[3].uval.lproc = begin ;

	symtab[4].name = "end" ;
	symtab[4].type = ENDST ;
	symtab[4].uval.value = 0 ;

	symtab[5].name = "stop";
	symtab[5].type = LPROC;
	symtab[5].uval.lproc = stop_ki;

	symtab[6].name = "run";
	symtab[6].type = NAME ;
	symtab[6].uval.value = RUN;

	symtab[7].name = "open";
	symtab[7].type = NAME;
	symtab[7].uval.value = OPN;

	symtab[8].name = "close" ;
	symtab[8].type = NAME;
	symtab[8].uval.value = CLSE;

	symtab[9].name = "low";
	symtab[9].type = NAME;
	symtab[9].uval.value = LOW;

	symtab[10].name = "high";
	symtab[10].type = NAME;
	symtab[10].uval.value = HIGH;

	symtab[11].name = "on";
	symtab[11].type = NAME;
	symtab[11].uval.value = ON;

	symtab[12].name = "off";
	symtab[12].type = NAME;
	symtab[12].uval.value = OFF;

	symtab[13].name = "xeq" ;
	symtab[13].type = LPROC ;
	symtab[13].uval.lproc = ixeq ;

	symtab[14].name = "sys" ;
	symtab[14].type = LPROC ;
	symtab[14].uval.lproc = isys ;

	symtab[15].name = "sleep" ;
	symtab[15].type = LPROC ;
	symtab[15].uval.lproc = isleep ;

	symtab[16].name = "pause" ;
	symtab[16].type = LPROC ;
	symtab[16].uval.lproc = ipause ;

	symtab[17].name = "beep";
	symtab[17].type = LPROC;
	symtab[17].uval.lproc = ibeep;

	symtab[18].name = "sel";		/* AFB_LIB.C routines */
	symtab[18].type = LPROC;
	symtab[18].uval.lproc = sel;

	symtab[19].name = "sfw";
	symtab[19].type = LPROC;
	symtab[19].uval.lproc = sfw;

	symtab[20].name = "camid";		/* Note! This is AFB id. */
	symtab[20].type = LPROC;
	symtab[20].uval.lproc = afb_id;

	symtab[21].name = "rfw";
	symtab[21].type = LPROC;
	symtab[21].uval.lproc = rfw;

	symtab[22].name = "tei";
	symtab[22].type = LPROC;
	symtab[22].uval.lproc = tei;

	symtab[23].name = "tee";
	symtab[23].type = LPROC;
	symtab[23].uval.lproc = tee;

	symtab[24].name = "td";
	symtab[24].type = LPROC;
	symtab[24].uval.lproc = td;

	symtab[25].name = "tcf";
	symtab[25].type = LPROC;
	symtab[25].uval.lproc = tcf;

	symtab[26].name = "tfw";
	symtab[26].type = LPROC;
	symtab[26].uval.lproc = tfw;

	symtab[27].name = "heater";
	symtab[27].type = LPROC;
	symtab[27].uval.lproc = heater;

	symtab[28].name = "acpower";
	symtab[28].type = LPROC;
	symtab[28].uval.lproc = acpower;

	symtab[29].name = "plus5";
	symtab[29].type = LPROC;
	symtab[29].uval.lproc = plus5;

	symtab[30].name = "plus15";
	symtab[30].type = LPROC;
	symtab[30].uval.lproc = plus15;

	symtab[31].name = "minus15";
	symtab[31].type = LPROC;
	symtab[31].uval.lproc = minus15;

	symtab[32].name = "stat";
	symtab[32].type = LPROC;
	symtab[32].uval.lproc = cam_stat;

	symtab[33].name = "cfifo";
	symtab[33].type = LPROC;
	symtab[33].uval.lproc = cfifo;

	symtab[34].name = "fccd";
	symtab[34].type = LPROC;
	symtab[34].uval.lproc = fccd;

	symtab[35].name = "gain";
	symtab[35].type = LPROC;
	symtab[35].uval.lproc = gain;

	symtab[36].name = "pb";
	symtab[36].type = LPROC;
	symtab[36].uval.lproc = pb;

	symtab[37].name = "pre";
	symtab[37].type = LPROC;
	symtab[37].uval.lproc = pre;

	symtab[38].name = "rm";
	symtab[38].type = LPROC;
	symtab[38].uval.lproc = rm;

	symtab[39].name = "roi";
	symtab[39].type = LPROC;
	symtab[39].uval.lproc = roi;

	symtab[40].name = "rr";
	symtab[40].type = LPROC;
	symtab[40].uval.lproc = rr;

	symtab[41].name = "sb";
	symtab[41].type = LPROC;
	symtab[41].uval.lproc = sb;

	symtab[42].name = "sh";
	symtab[42].type = LPROC;
	symtab[42].uval.lproc = sh;

	symtab[43].name = "unload";
	symtab[43].type = LPROC;
	symtab[43].uval.lproc = unload;

	symtab[44].name = "type";
	symtab[44].type = LPROC;
	symtab[44].uval.lproc = exp_type;

	symtab[45].name = "scale";
	symtab[45].type = LPROC;
	symtab[45].uval.lproc = scale;

	symtab[46].name = "expose";
	symtab[46].type = LPROC;
	symtab[46].uval.lproc = expose;

	symtab[47].name = "tp";
	symtab[47].type = LPROC;
	symtab[47].uval.lproc = tp;

	symtab[48].name = "rd";
	symtab[48].type = LPROC;
	symtab[48].uval.lproc = rd;

	symtab[49].name = "wthd";
	symtab[49].type = LPROC;
	symtab[49].uval.lproc = wthd;

/*	symtab[50].name = "compare";
	symtab[50].type = LPROC;
	symtab[50].uval.lproc = compare;*/

	symtab[51].name = "view";
	symtab[51].type = LPROC;
	symtab[51].uval.lproc = view;

	symtab[52].name = "opmode";
	symtab[52].type = LPROC;
	symtab[52].uval.lproc = op_mode;

	symtab[53].name = "fstat";
	symtab[53].type = LPROC;
	symtab[53].uval.lproc = fan_stat;

	symtab[54].name = "afbx";
	symtab[54].type = LPROC;
	symtab[54].uval.lproc = reset_afb;
	
	symtab[55].name = "compress";
	symtab[55].type = LPROC;
	symtab[55].uval.lproc = compress;

	for ( i=56; i < STSIZE ; i++ )
	{
		symtab[i].name = "" ;
		symtab[i].type = UNDEF ;
		symtab[i].uval.value = 0 ;
	}
}

