/*  Function prototypes for KI and user functions. */

/*************************** ki.c *******************************/

void disp_omsg( int );
void print_string( int, int, char *, char );
void chron_func( void );
int getline ( FILE *, char *, register int );
char *get_nxt_tok( void );
int get_nxt_number ( void );
int strmatch ( char *, char * );
int set_cmdsrc ( char *, int );

/*************************** lcmds.c *******************************/

/* Symbol table initialization. */

void st_init( void );

/*************************** interp.c *******************************/

/* Routine to delete previous additions made to the symbol table*/

void delete( void );
char *iparse ( char *, entry_ptr *, register int * );
char *nsave ( register char * );
int isearch ( register char *, register int );
char *get_token ( register char *, register char *, int * );
int chtest ( register int );
int ishex ( int );
int convert( char * );
int htoi ( register int );
void iexec ( register pv_ptr );
pv_ptr clause ( register pv_ptr, int *, int * );
pv_ptr fptr ( register pv_ptr );	/* General case function description. */

/*************************** isym.c *******************************/

pv_ptr doproc( register pv_ptr );
pv_ptr begin ( register pv_ptr );
pv_ptr ixeq ( register pv_ptr );  
pv_ptr isys ( register pv_ptr );
pv_ptr isleep ( register pv_ptr ); 
pv_ptr ipause ( register pv_ptr ); 
pv_ptr ibeep ( register pv_ptr ); 
pv_ptr date ( register pv_ptr );
pv_ptr prt ( register pv_ptr );
pv_ptr stop_ki ( register pv_ptr );
long dos_ticks( void );

/*************************** init_ki.c *******************************/

void terminate_ki ( void );
void init_ki ( void );
void init_struct ( void );
void genbitmap( void );
void show_usage( void );
void do_startup ( char * );

/*************************** bgnd_fnc.c ******************************/

void sample_temperatures( void );

/*************************** afb_lib.c *******************************/

pv_ptr sel ( register pv_ptr );    /* Select camera, make it current. */
pv_ptr sfw( register pv_ptr );    /* Set Filter Wheel Position */
pv_ptr afb_id ( register pv_ptr );    /* Read AFB ID Bits */
pv_ptr rfw ( register pv_ptr );    /* Read Filter Wheel Position */
pv_ptr tei ( register pv_ptr );    /* Read Enclosure Internal Ambient Temp. */
pv_ptr tee ( register pv_ptr );    /* Read Enclosure External Ambient Temp. */
pv_ptr td ( register pv_ptr );    /* Read Dome Temperature */
pv_ptr tcf ( register pv_ptr );    /* Read CCD Temperature, Fine */
pv_ptr tfw ( register pv_ptr );    /* Read Filter Wheel Temperature */
pv_ptr heater ( register pv_ptr );    /* Read Heater Status */
pv_ptr acpower ( register pv_ptr );    /* Read power - AC to electronics. */
pv_ptr plus5 ( register pv_ptr );    /* Read power - plus 5 volt rail. */
pv_ptr plus15 ( register pv_ptr );    /* Read power - plus 15 volt rail. */
pv_ptr minus15 ( register pv_ptr );    /* Read power - minus 15 volt rail. */
pv_ptr cam_stat ( register pv_ptr );    /* Show camera Status */
pv_ptr fan_stat ( register pv_ptr );    /* Read Fan Status */
pv_ptr reset_afb ( register pv_ptr );    /* Reset AFB for selected camera. */
void select_camera ( int );
int com_send( int, char  );
int com_rcv( int, int * );
void update_temp( int *, int, int );
int match_afb( void );

/*************************** cam_cont.c *******************************/

pv_ptr cfifo( register pv_ptr );	
pv_ptr fccd( register pv_ptr );	
pv_ptr gain( register pv_ptr );
pv_ptr pb( register pv_ptr );
pv_ptr pre ( register pv_ptr );
pv_ptr rm ( register pv_ptr );
pv_ptr roi ( register pv_ptr );
pv_ptr rr ( register pv_ptr );	
pv_ptr sb ( register pv_ptr );
pv_ptr sh ( register pv_ptr );
pv_ptr unload ( register pv_ptr );
pv_ptr exp_type ( register pv_ptr );
pv_ptr scale ( register pv_ptr );
pv_ptr expose ( register pv_ptr );
pv_ptr rd ( register pv_ptr );
pv_ptr tp ( register pv_ptr );
pv_ptr wthd ( register pv_ptr );
pv_ptr op_mode ( register pv_ptr );
void scan_min_max( unsigned far * );
void do_gzip( char * );
pv_ptr compress ( register pv_ptr );
void xeq_compress( char * );

/*************************** compare.c *******************************/

pv_ptr compare ( register pv_ptr );

/*************************** view.c *******************************/

pv_ptr view ( register pv_ptr );
void	setvideomode( int );
int	getvideomode( void );
void clear( void );
void Draw_colors( int, int, int, char );
void drawhistogram( int );
void draw_frames( void );
void scan_image( unsigned char far *, int * );
void overlay_text( int );
void annotate ( int );
void scan_histogram( unsigned far *, int, int );
void display_temps( void );

/*************************** lzw15.c *******************************/

long file_size( char * );
BIT_FILE     *OpenInputBitFile( char *name );
BIT_FILE     *OpenOutputBitFile( char *name );
void          OutputBit( BIT_FILE *bit_file, int bit );
void          OutputBits( BIT_FILE *bit_file,
                          unsigned long code, int count );
int           InputBit( BIT_FILE *bit_file );
unsigned long InputBits( BIT_FILE *bit_file, int bit_count );
void          CloseInputBitFile( BIT_FILE *bit_file );
void          CloseOutputBitFile( BIT_FILE *bit_file );
void          FilePrintBinary( FILE *file, unsigned int code, int bits );
void	      CompressFile( FILE *input, BIT_FILE *output );
void  	      fatal_error( char *fmt, ... );

/**************************** svga.c ********************************/

void Select_Graphics( void );
void Select_Page( int );
int getvideomode(  void );
void setvideomode( int mode );
void svga_color_set( int, int, int, int );
void clear( void );
void disable_refresh( void );
void enable_refresh( void );
void Write_Video( int, int, int, int, unsigned char far * );
void Draw_HLine( int, int, int, char );
void Draw_VLine( int, int, int, char );
void Write_Pixel( int, int, char );
void plot_char( int, int, int, char );

